﻿function byYX(a,b) {
    var
        aY = a.geometricBounds[0],
        bY = b.geometricBounds[0],
        aX = a.geometricBounds[1],
        bX = b.geometricBounds[1],
        dy = aY-bY,
        dx = aX-bX;
 
    return dy?dy:dx;
}

var ProgressBar = function(/*str*/title){
     var w = new Window('palette', ' '+title, {x:0, y:0, width:340, height:60}),
          pb = w.add('progressbar', {x:20, y:12, width:300, height:12}, 0, 100),
          st = w.add('statictext', {x:10, y:36, width:320, height:20}, '');
     st.justify = 'center';
     w.center();
     this.reset = function(msg,maxValue)
          {
          st.text = msg;
          pb.value = 0;
          pb.maxvalue = maxValue||0;
          pb.visible = !!maxValue;
          w.show();
          };
     this.hit = function() {++pb.value;};
     this.hide = function() {w.hide();};
     this.close = function() {w.close();};
};
function main(){
var doc=app.activeDocument;
var ll=doc.pages.length;
var myFrame0=app.activeDocument.pages[0].textFrames.add();
var myStory=myFrame0.parentStory;

var pBar = new ProgressBar("Progress");
pBar.reset("Wait for it.. Wait...", ll);
for (var i=0;i<ll;i++){
    var myPage = doc.pages[i].duplicate();
                
            while (myPage.groups.length>0){myPage.groups.everyItem().ungroup();}
            myArray=myPage.textFrames.everyItem().getElements();
            myArray.sort(byYX);

            for (var j=0;j<myArray.length; j++){
                
               if (myArray[j].parentStory.length>2)
               {    
                        myArray[j].parentStory.convertBulletsAndNumberingToText ();                        
                        myArray[j].parentStory.texts[0].duplicate(LocationOptions.after,myStory.insertionPoints[-1]);
                        myArray[j].parentStory.remove();
                        myStory.insertionPoints[-1].contents="\r";
                        }
                }    
            myStory.insertionPoints[-1].contents="\r******** Page "+doc.pages[i].name+" ********\r\r";
            myPage.remove();
            pBar.hit()
}

var myFilePath = File.saveDialog("Save Exported File As:", "*.rtf");
if (myFilePath){
myStory.exportFile(ExportFormat.RTF, myFilePath ,true);}
myFrame0.remove();
}
try {
    app.doScript('main()', undefined, undefined, UndoModes.ENTIRE_SCRIPT, 'Export All');}
	catch (e)
	{
		alert(e.message + "\r(line " + e.line + ")")
	};